function [QmapLR,QmapHR] =  generateQmap(imSize,K,type,opts)

switch type
    case 'uniform'
        q       =  opts.q;
        QmapHR  =  q*ones(imSize*K);
        QmapLR  =  q*ones(imSize);
    case 'bisection'
        y       =  opts.y;
        qmax    =  opts.qmax;
        Qblock  =  opts.Qblock;
        oracleQmap = opts.oracleQmap;
        T_adapt =  opts.T_adapt;
        QmapHR  =  BisectionAdapt(y,qmax,Qblock,oracleQmap,T_adapt,[],0);
        QmapLR  =  QmapHR(1:K:end,1:K:end);
    otherwise
        fprintf('Undefined Qmap Type');
end